; Additional packages are in s48-package-defs.scm (for loading into
; Scheme 48) and ps-package-defs.scm (for compiling as Pre-Scheme).

(define-structure simple-i/o simple-i/o-interface
  (open pre-scheme)
  (files dumb-io))

(define-structure memory memory-interface
  (open pre-scheme vm-utilities)
  (files memory))

(define-structure vm-architecture vm-architecture-interface
  (open pre-scheme ps-enumerated)
  (files arch))

(define-structure data data-interface
  (open pre-scheme vm-utilities ps-enumerated
	system-spec vm-architecture memory)
  (files data))

(define-structures ((heap heap-interface)
		    (stob stob-interface))
  (open pre-scheme vm-utilities vm-architecture memory data simple-i/o)
  (files heap stob gc))

(define-structure struct struct-interface
  (open pre-scheme vm-utilities
	vm-architecture memory data stob)
  (for-syntax (open scheme vm-architecture destructuring))
  (files struct))

(define-structure vmio vmio-interface
  (open pre-scheme vm-utilities data stob struct memory
	vm-architecture)  ; port-status
  (files vmio))

(define-structures ((stack stack-interface)
		    (environment environment-interface))
  (open pre-scheme vm-utilities ps-enumerated
	vm-architecture memory data stob struct)
  (files stack env))

(define-structure fixnum-arithmetic fixnum-arithmetic-interface
  (open pre-scheme vm-utilities data
	memory)  ; bits-per-cell
  (files arith))

(define-structure interpreter interpreter-interface
  (open pre-scheme vm-utilities vm-architecture ps-enumerated
	memory data stob struct vmio simple-i/o
	heap stack environment external fixnum-arithmetic)
  (for-syntax (open scheme destructuring))
  (files interp define-primitive prim prim-io resume)
  (begin
    (define (write-instruction template pc) 0))) ; stub

; From Scheme 48
(define-structure ps-enumerated ps-enumerated-interface
  (open pre-scheme)
  (files defenum))

; For debugging

(define-structure vm-disassembler (export disassemble write-instruction)
  (open scheme
	struct
        enumerated              ; enumerand->name
        vm-architecture
	bitwise                 ; arithmetic-shift
	signals)                ; error
  (files disasm))

